



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Xcode4.6 开发 metaio 增强现实 项目（二）--增强现实的实现</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Xcode4.6 开发 metaio 增强现实 项目（二）--增强现实的实现</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-26 09:36:54 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>经过昨天的一些步骤，我们已经将我们的IOS应用的基本界面搭建好，下面我们将开始新的征程：增强现实技术的实现；</p>
<p>进入webView后，我们要选用我们这次需要用的<img referrerpolicy="no-referrer"src="https://www.cnblogs.com/jiangu66/admin/" />nib文件，它是一个家居摆放应用的界面文件，控制它的是视图控制对象&nbsp;Tutorial7ViewController.mm，现在我们就从此文件开始我们的增强现实之旅；</p>
<p>首先是增强现实显示除家居的流程：</p>
<p>1、当摄像头处于激活状态时使用GPS跟踪</p>
<p>2、设置坐标的偏移</p>
<p>3、拍摄一张照片并且设置图片作为跟踪图样</p>
<p>4、载入机器人模型的跟踪配置文件</p>
<p>5、将模型放置在图样上（手势可以应用到模型上）</p>
<p>6、截一个屏</p>
<p>7、通过清除跟踪图样和重新激活摄像头来重置进程</p>
<p>接着来看<img referrerpolicy="no-referrer"src="https://www.cnblogs.com/jiangu66/admin/" />文件，首先声明四个指向3D模型的变量</p>
<pre class="prettyprint linenums">    metaio::IGeometry* m_metaioMan;<br />
    metaio::IGeometry* m_chair;<br />
    metaio::IGeometry* m_tv;<br />
    metaio::IGeometry* m_screen;</pre>
<p>再声明一个处理手势操作的变量</p>
<pre class="prettyprint linenums">    //手势处理拖拽、缩放、旋转<br />
    GestureHandlerIOS* m_gestureHandler;</pre>
<p>两个开关变量</p>
<pre class="prettyprint linenums">    //开关变量来标识手势识别enabled<br />
    int m_gestures;<br />
    //表明用户是否做出了拍照的请求<br />
    bool m_imageTaken;</pre>
<p>当然还要记录下3D物体移动后的实时位置信息（增强现实）</p>
<pre class="prettyprint linenums">    //记录3D模型实时的方位值<br />
	metaio::TrackingValues m_pose;</pre>
<p>最后就是一堆的方法声明，包括显示\隐藏3D模型、右下角按钮和左上角选择按钮的插座变量声明：</p>
<pre class="prettyprint linenums">- (IBAction)onTVButtonClick:(id)sender;<br />
- (IBAction)onChairButtonClick:(id)sender;<br />
- (IBAction)onManButtonClick:(id)sender;

// handle buttom buttons<br />
- (IBAction)onTakePicture:(id)sender;<br />
- (IBAction)onSaveScreen:(id)sender;<br />
- (IBAction)onClearScreen:(id)sender;

//show/hide the geometries<br />
- (void)setVisibleTV:(bool)visible;<br />
- (void)setVisibleChair:(bool)visible;<br />
- (void)setVisibleMan:(bool)visible;</pre>
<p>当然还有一个子视图的声明：</p>
<pre class="prettyprint linenums">@property (unsafe_unretained, nonatomic) IBOutlet UIView *subview;</pre>
<p>现在进入Tutorial7ViewController.mm，<br />
 先来到ViewDidLoad，这个方法是在视图加载晚了之后运行方法，因此在里面设置subView为透明、开启所有手势并且加载跟踪配置信息，代码如下：</p>
<pre class="prettyprint linenums">    [super viewDidLoad];

    // make the subview transparent（让subView透明）<br />
    subview.backgroundColor = [UIColor clearColor];

    m_gestures = 0xFF; //enables all gestures（开启所有的手势）<br />
    m_gestureHandler = [[GestureHandlerIOS alloc] initWithSDK:m_metaioSDK withView:glView withGestures:m_gestures];

    m_imageTaken = false;

    // load our tracking configuration（加载跟踪配置信息）<br />
    bool success = m_metaioSDK-&gt;setTrackingConfiguration("ORIENTATION_FLOOR");<br />
    NSLog(@"ORIENTATION tracking has been loaded: %d", (int)success);</pre>
<p>下载需要加载3D对象资源了，一般资源的加载都是在ViewDidLoad方法中实现的，所以开始我们的加载：（增强现实）</p>
<p>首先是3D机器人的加载，首先找到它对应已经加入Copy Bundle Resouce里的路径，然后通过createGeometry方法创建3D模型，当然还要用setScale<br /> 设置它的初始化大小；最关键的一步就是到现在3D模型已经显示出来了，但是初始的时候是不应该有的，所以我们人为的把它隐藏起来，方法为</p>
<p>[selfsetVisibleMan:false];，整体代码如下：</p>
<pre class="prettyprint linenums">//（加载机器人）<br />
    NSString* manPath = [[NSBundle mainBundle] pathForResource:@"metaioman" ofType:@"md2" inDirectory:@"tutorialContent_crossplatform/Tutorial7/Assets7"];

	if(manPath)<br />
	{<br />
		// m_metaioMan指向3D机器人<br />
        m_metaioMan =  m_metaioSDK-&gt;createGeometry([manPath UTF8String]);<br />
        if(m_metaioMan)<br />
        {<br />
            // 设置其最大缩放量<br />
            m_metaioMan-&gt;setScale(metaio::Vector3d(5.0,5.0,5.0));<br />
            // 添加手势识别<br />
            [m_gestureHandler addObject:m_metaioMan andGroup:1];<br />
        }<br />
        else<br />
        {<br />
            NSLog(@"Error loading the metaio man model: %@", manPath);<br />
        }<br />
    }<br />
    // 开始的时候隐藏3D模型<br />
    [self setVisibleMan:false];
</pre>
<p>椅子、电视的加载方式大同小异，有几点不同的地方在于：椅子、电脑没有trackingData，所以需要设定他们的旋转角度和位置，代码如下：</p>
<pre class="prettyprint linenums">            //rotate the chair to be upright<br />
            m_chair-&gt;setRotation(metaio::Rotation(M_PI_2, 0.0, 0.0));<br />
            m_chair-&gt;setTranslation(metaio::Vector3d(0.0, 0.0, 0.0));</pre>
<p>同时，屏幕对象screen需要加载电影文件，代码如下：</p>
<pre class="prettyprint linenums">            // start the movie<br />
            NSString* moviePath = [[NSBundle mainBundle] pathForResource:@"sintel" ofType:@"3g2" inDirectory:@"tutorialContent_crossplatform/Tutorial7/Assets7"];<br />
            m_screen-&gt;setMovieTexture([moviePath UTF8String]);</pre>
<p>接下来就是家居按钮的处理了，它采用的是for循环遍历整个view的方法，我觉得它不用插座将nib文件的button和视图控制文件联系起来的原因在于这样的话可以批处理这些对象而不用一个一个的连接再处理</p>
<p>[subView isKindOfClass:[UIButtonclass]]这句话用了isKindOfClass来筛选button控件，设置按钮选择与未选的图片变换；</p>
<pre class="prettyprint linenums"></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qn7gg8r.html">Amazon Interview &vert; Set 27</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93jve08.html">&lpar;原&rpar;android的alertdialog中加入edittext但是不弹出软键盘等问题的解决与原因</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxgyjz9.html">LinqToXml</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kydo69.html">tsql的奇特语法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z111jx9.html">迪米特法则（LoD），即最少知识原则</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmj2x69.html">Tomcat发布网站知识集锦</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydv3vmq.html">Android--PullToRefreshListView 的简单使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0v73eq.html">修复ecshop商品重量BUG小数位增至五位</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y0n70q.html">Jquery css函数用法&lpar;判断标签是否拥有某属性&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdvjme8.html">SQL Server 存储过程之基础知识（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1n4lz9.html">ActionSupport&period;getText&lpar;&rpar;方法 以及 js中：&amp;lt&semi;s&colon;text name&equals;&amp;quot&semi;&amp;quot&semi; &sol;&amp;gt&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zm7ze9.html">Python中的继承</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpp1xvq.html">Centos 6&period;5下一个SNMP简单配置&lpar;snmp protocol v3，监控宝&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pljn48.html">eclipse自动提示设置以及问题：去除变量自动提示（图文详解）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp65yj9.html">C语言第八次作业</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mgoyn8.html">第四周WordCount优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdl71v9.html">nginx&period;conf&lpar;centos7 1&period;14&rpar;主配置文件修改</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wk73rq.html">MFS&plus;Keepalived双机高可用热备方案操作记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2pdro9.html">为什么要使用getter&sol;setter</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2g36z9.html">php表单中如何获取单选按钮与复选按钮的值（示例）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q1krjxz9.html">工作流设计参考（包括PHP实现）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ey4olz9.html">思维方式--SMART原则</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2j53138.html">C&num; 在本地创建文件夹及子文件夹</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me2rnpq.html">wpa&lowbar;cli P2P 连接相关的调试命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gejrpl8.html">jQuery弹出窗口完整代码</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1yozxq.html">javascript转换&period;net DateTime方法 （比如转换&bsol;&sol;Date&lpar;1426056463000&rpar;&bsol;&sol;）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zo3xk9.html">zxing二维码扫描的流程简析（Android版）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rg5m048.html">Orchard Module&comma;Theme&comma;Core扩展加载概述</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv12pp1q.html">W3C的CORS Specification</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rg5ppm8.html">Push Notification总结系列（一）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
